#include "partida.h"
#include <cstdlib>
#include <iostream>
#ifdef WIN32
	#include<windows.h>
#endif
#include <fstream>
#include <sys/time.h>
#include <ctime>
#include <unistd.h>
#include "StdPijo.h"
#include <stdio.h>
#include <time.h>

#include <stdlib.h>



using namespace STDP;

#include "constantes.h"


// Funciones y metodos
void centrado(string cadena,StdPijo stdp);
void load_spanish();
void centrado_tablero(string cadena,StdPijo stdp);
void menu_inicial(StdPijo& stdp);
void credits(StdPijo stdp);
void preparar_partida_nueva(Partida &partida, int nivel);
int activar_reloj(timeval start);
int apagar_reloj(timeval end);
long int calcula_puntuacion(long int play,long int stop,int nivel);
void loading(StdPijo stdp);
void ranking(StdPijo stdp);





int main(int argc, char *argv[]) {
    char seleccion;
	char modo;
	char idiomaV;
	int posicion = 1;
	char avatar;
	string temporal;
    int fila_origen = 0;
    int columna_origen = 0;
    bool solucion = false;
	int nivel = 1;
	Partida partida;
	//TIEMPO
	struct timeval start, end;
	long int puntuacionF = 0;



	
	 StdPijo& stdp = StdPijo::p();

	    // Inicializamos la pantalla
	    stdp.init();

	    // Borramos la pantalla
	    stdp.clearScreen();

	   stdp.setGlobalEscapeDelay(0);






	//SELECCION DE IDIOMA
	   	   stdp.setColor(ABOLD, CCYAN , CBLACK);
         stdp.writeStr(saltoG.c_str());
         centrado(bordeidioma,stdp);
         stdp.writeStr(saltoP.c_str());
         centrado(selectIdioma,stdp);
         stdp.writeStr(saltoP.c_str());
         centrado(bordeidioma,stdp);
         stdp.setColor(ABOLD, CWHITE , CBLACK);
         stdp.writeStr(saltoP.c_str());
	     stdp.writeStr(saltoP.c_str());
	     stdp.writeStr(margenIdioma.c_str());
	     stdp.writeStr(enum1.c_str());
	     stdp.writeStr(Idioma1.c_str());
	     stdp.writeStr(margenIdioma.c_str());
	     stdp.writeStr(enum2.c_str());
	     stdp.writeStr(Idioma2.c_str());
	     stdp.writeStr(salto.c_str());
	     centrado(opcionI,stdp);

	    while((seleccion != K1) && (seleccion != K2)){
	    	   seleccion = stdp.getKey();
	    }
    //si es espa�ol cargar espa�ol
    if(seleccion == '2') load_spanish();

	seleccion = 0;
	
	// PANTALLA DE PRESENTACION
	stdp.clearScreen();


	stdp.setColor(ABOLD, CGREEN , CBLACK);
	stdp.writeStr(saltoG.c_str());
	stdp.writeStr(saltoI.c_str());
	stdp.writeStr(separador.c_str());
	stdp.writeStr(saltoI.c_str());
	stdp.writeStr(medio.c_str());
	stdp.writeStr(saltoI.c_str());
	stdp.writeStr(titulo.c_str());
	stdp.writeStr(saltoI.c_str());
	stdp.writeStr(medio.c_str());
	stdp.writeStr(saltoI.c_str());
	stdp.writeStr(subtitulo.c_str());
	stdp.writeStr(saltoI.c_str());
	stdp.writeStr(medio.c_str());
	stdp.writeStr(saltoI.c_str());
	stdp.writeStr(separador.c_str());
	fflush(stdin);
	fflush(stdout);
	stdp.refreshScr();
	sleep(3);




	do{
		//MENU

			stdp.clearScreen();
			menu_inicial(stdp);
			stdp.setColor(ABOLD, CWHITE , CBLACK);
			stdp.writeStr(enum1.c_str());
			stdp.writeStr(opcion1.c_str());
			stdp.writeStr(enum2.c_str());
			stdp.writeStr(opcion2.c_str());
			stdp.writeStr(enum3.c_str());
			stdp.writeStr(opcion4.c_str());
			stdp.writeStr(enum4.c_str());
			stdp.writeStr(opcion5.c_str());
			stdp.setColor(ABOLD, CYELLOW , CBLACK);
			stdp.writeStr(opcion.c_str());
			stdp.setColor(ABOLD, CWHITE , CBLACK);
			while((seleccion != K1) && (seleccion != K2) && (seleccion != K3) && (seleccion != K4)) seleccion = stdp.getKey();




		// OPCION JUGAR

		if (seleccion == K1) {

			stdp.clearScreen();



           // New Game
           seleccion = 0;
           stdp.clearScreen();
           // Punto de partida
           do{
              preparar_partida_nueva(partida, nivel);
              fila_origen =  partida.getTablero().getCasillaJugador().getX();
              columna_origen = partida.getTablero().getCasillaJugador().getY();
              solucion = partida.establecerCaminoSeguro(fila_origen, columna_origen);
           }while(solucion == false);
           stdp.setColor(ABLINK, CYELLOW, CBLACK);
           stdp.writeStr(saltoG.c_str());
           centrado(cargandoN,stdp);
           stdp.writeStr(saltoP.c_str());
           loading(stdp);
           fflush(stdin);
           	fflush(stdout);
           	stdp.refreshScr();
           sleep(1);
           //TIEMPO INICIAL
           long int play = activar_reloj(start);
          do {
        	  	   stdp.clearScreen();




        	  	   stdp.setColor(ABOLD, CWHITE , CBLACK);
                   stdp.writeStr(salto.c_str());
                   centrado_tablero(partida.getTablero().visualizarTablero(avatar),stdp);
                   stdp.writeStr(salto.c_str());
                   stdp.setColor(ABOLD, CBLUE , CBLACK);
                   centrado(separador,stdp);
                   centrado(moveUP,stdp);
                   centrado(moveDOWN,stdp);
                   centrado(moveRIGHT,stdp);
                   centrado(moveLEFT,stdp);
                   centrado(abandonar,stdp);
                   centrado(separador,stdp);
                   stdp.writeStr(saltoP.c_str());
                   // Mostrar informaci�n sobre las trampas situadas alrededor de la casilla del Jugador
                   stdp.setColor(ABOLD, CYELLOW , CBLACK);
                   stdp.writeStr(trampasC.c_str());
                   char buffer1 [5];
                   int n = 0;
                   int num = partida.getTablero().getTrampasCercanas(partida.getTablero().getCasillaJugador());
                   n=sprintf (buffer1, "%d", num);
                   char a =buffer1[0];
                   stdp.writeChar(a);
                   stdp.setColor(ABOLD, CWHITE , CBLACK);


               while((seleccion != KUP) && (seleccion != KDOWN) && (seleccion != KLEFT) && (seleccion != KRIGHT) && (seleccion != KESCAPE)) seleccion = stdp.getKey();



               switch (seleccion) {

                      case KUP:
                    	  partida.moverJugador('W', partida.getTablero());
                    	  seleccion = 0;
                    	  break;
                      case KDOWN: partida.moverJugador('S', partida.getTablero());
                      seleccion = 0;
                      break;
                     case KRIGHT: partida.moverJugador('D', partida.getTablero());
                     seleccion = 0;
                     break;
                      case KLEFT: partida.moverJugador('A', partida.getTablero());
                      seleccion = 0;
                      break;
                      case KESCAPE:  break;
               }
               // Si se pisa una Mina, se muestra el tablero con las minas.



                				//PIERDES
                            if (partida.getTablero().getCasillaJugador().getTrampaCasilla()) {

                            	 seleccion=0;
                                stdp.clearScreen();
                            	stdp.writeStr(saltoG.c_str());
                                centrado_tablero(partida.getTablero().visualizarTrampasTablero(avatar),stdp); //visualizar tablero
                                stdp.writeStr(saltoP.c_str());
                                stdp.setColor(ABOLD, CBLUE, CBLACK);
                                centrado(trampa,stdp); // YOU ACTIVATED A TRAP
                                stdp.setColor(ABOLD, CWHITE, CBLACK);
                                while(seleccion != KESPACIO) seleccion = stdp.getKey();
                                partida.~Partida();
                                seleccion = KESCAPE;

                            }//GANAS
                            else if(partida.getTablero().getCasillaJugador().getY() == K_COLUMNA-1){
                            	stdp.clearScreen();
                            	//TIEMPO FINAL

                            	 fflush(stdin);
                            	 fflush(stdout);
                            	 stdp.refreshScr();
                            	 long int stop = apagar_reloj(end);

                            	 //PUNTUACION
                            	 puntuacionF = puntuacionF + calcula_puntuacion(play,stop,nivel);
                            	 if(puntuacionF < 0) puntuacionF = 0;
                            	solucion = false;
                            	seleccion = 0;
                                stdp.writeStr(saltoG.c_str());
            					centrado_tablero(partida.getTablero().visualizarTrampasTablero(avatar),stdp);
            					stdp.writeStr(saltoP.c_str());
            					stdp.setColor(ABOLD, CBLUE, CBLACK);
            					centrado(nivelP,stdp);
            					stdp.writeStr(salto.c_str());
            					stdp.writeStr(tiempoT.c_str());
            					fflush(stdin);
            					fflush(stdout);
            					stdp.refreshScr();
            					 printf("%ld", ((stop) - (play)));
            					 printf(" ");
            					 stdp.writeStr(segundos.c_str());
            					 stdp.writeStr(saltoP.c_str());
            					 stdp.writeStr(scoreF.c_str());
            					 fflush(stdin);
            					 fflush(stdout);
            					 stdp.refreshScr();
            					 printf("%ld", puntuacionF);
            					 printf(" ");
            					 stdp.writeStr(points.c_str());
            					while(seleccion !=KESPACIO)seleccion = stdp.getKey();
            					nivel++;
            					stdp.setColor(ABOLD, CWHITE, CBLACK);
            					stdp.clearScreen();
            					do{
                                        preparar_partida_nueva(partida, nivel);
                                       fila_origen =  partida.getTablero().getCasillaJugador().getX();
                                       columna_origen = partida.getTablero().getCasillaJugador().getY();
                                       solucion = partida.establecerCaminoSeguro(fila_origen, columna_origen);
            					}while(solucion == false);
            					stdp.setColor(ABLINK, CYELLOW, CBLACK);
            					stdp.writeStr(saltoG.c_str());
            					centrado(cargandoN,stdp);
            					stdp.writeStr(saltoP.c_str());
            					loading(stdp);
            					fflush(stdin);
            					fflush(stdout);
            					stdp.refreshScr();
            					 sleep(1);
            					 stdp.setColor(ABLINK, CWHITE, CBLACK);
                            }
                 }while(seleccion != KESCAPE);

		}else if(seleccion == K2){
			seleccion = 0;
			ranking(stdp);
			}else if(seleccion == K3){
				seleccion = 0;
				credits(stdp);
			}

	}while(seleccion != K4);
		stdp.refreshScr();
	   // Restauramos el estado original del terminal
	  	       stdp.end();

	  	        // Salimos sin errores
	  	        return 0;
}


// PREPARAR PARTIDA NUEVA CON UN NIVEL DETERMINADO
//****************************************************************************************
void preparar_partida_nueva(Partida &partida, int nivel) {
     // Iniciar Tablero.
     partida.getTablero().inicializa_tablero();
     // Situar Trampas.
     partida.getTablero().putTrampas(nivel);
     // Situar Jugador en Casilla inicial.
     partida.getTablero().getCasilla(fila_inicio,columna_inicio).putJugadorCasilla(true);
     // Quitar posible trampa de la casilla inicial.
     partida.getTablero().getCasilla(fila_inicio,columna_inicio).putTrampaCasilla(false);
}


//MENU INICIAL
//*********************************************************************************************
void menu_inicial(StdPijo& stdp){
		stdp.setColor(ABOLD, CGREEN , CBLACK);
		stdp.writeStr(separador.c_str());
		stdp.writeStr(medio.c_str());
		stdp.writeStr(titulo.c_str());;
		stdp.writeStr(medio.c_str());
		stdp.writeStr(subtitulo.c_str());
		stdp.writeStr(medio.c_str());
		stdp.writeStr(separador.c_str());
		stdp.writeStr(saltoG.c_str());
		stdp.writeStr(saltoP.c_str());
}



// CENTRAR TEXTO
//*********************************************************************************************
void centrado(string cadena,StdPijo stdp) {
     int margen = 0;
     int longitud = 0;

     
     longitud = cadena.size();
     margen = (80-longitud)/2;
     for (int pos=0; pos < margen; pos++) stdp.writeStr(" ");
     stdp.writeStr(cadena.c_str());
}

// CREDITS
//*************************************************************************************
void credits(StdPijo stdp) {
	int credito=0;
	stdp.clearScreen();
	stdp.writeStr(credito1.c_str());
	stdp.writeStr(salto.c_str());
	stdp.setColor(ABOLD, CYELLOW, CBLACK);
	stdp.writeStr(credito2.c_str());
	stdp.writeStr(credito3.c_str());
	stdp.writeStr(credito4.c_str());
	stdp.writeStr(credito5.c_str());
	stdp.writeStr(credito6.c_str());
	stdp.writeStr(credito7.c_str());
	stdp.writeStr(credito8.c_str());
	stdp.writeStr(credito9.c_str());
	stdp.writeStr(salto.c_str());
	stdp.setColor(ABOLD, CWHITE, CBLACK);
	stdp.writeStr(pauseT.c_str());
	while(credito != KESPACIO) credito=stdp.getKey();
}


              

// CAMBIAR IDIOMA
//*************************************************************************************
void load_spanish(){
    

    EndGame   = "**        FIN DEL JUEGO         **\n";
    opcion1 = "Jugar\n";
    opcion2 = "Ranking\n";
    opcion4 = "Creditos\n";
    opcion5 = "Salir\n";
    opcion = "\nSeleccione una Opcion: ";
    credito1="Juego creado por: \n";
    MenuJ ="Volver al menu\n";
    pauseT ="Presione espacio para continuar: ";
    trampa = "HAS ACTIVADO UNA TRAMPA!\n";
    nivelP ="HAS CRUZADO EL LABERINTO!\n";
    cargandoN="*** CARGANDO UN JUEGO CON SOLUCION ***\n";
    trampasC ="Trampas cercanas: ";
    tiempoT = "Tiempo jugado: ";
    segundos = "segundos.";
    scoreF = "Puntuacion: ";
    points = "puntos.";
    suficiente = "Tus puntuaciones no merecen estar en el ranking.\n";
}


// CENTRAR TABLERO
//*********************************************************************************************
void centrado_tablero(string cadena,StdPijo stdp) {
     int margen = 0;
     string frase = "";
     int long_fila = 0;
     int longitud = 0;
     int posicion = 0;

     longitud = cadena.size();  

     while (posicion < longitud) { 
  
         while (cadena[posicion] != '\n') {
               frase += cadena[posicion];
               posicion++;
               long_fila++;
         }
         
         margen = (80-long_fila)/2;
         for (int pos=0; pos < margen; pos++) stdp.writeStr(" ");
         stdp.writeStr(frase.c_str());
         stdp.writeStr(saltoP.c_str());
         posicion = posicion+1;
         long_fila = 0;
         frase = "";
     }
}



int activar_reloj(timeval start){

	gettimeofday(&start, NULL);
	return start.tv_sec;
}

int apagar_reloj(timeval end) {
	gettimeofday(&end, NULL);
	return  end.tv_sec;
}



long int calcula_puntuacion(long int play,long int stop,int nivel){

	long int puntuacion = nivel * 70 - (stop - play);

	return puntuacion;


}

void loading(StdPijo stdp){

	int n = 0;
	stdp.writeStr("                                 *");
	while(n < 7){
		fflush(stdin);
			fflush(stdout);
			stdp.refreshScr();
		sleep(1);
		stdp.writeStr("*");
		n++;
	}
}


void ranking(StdPijo stdp){

	stdp.clearScreen();
	int rank = 0;
	stdp.setColor(ABOLD, CCYAN, CBLACK);
	stdp.writeStr(salto.c_str());
	stdp.writeStr(separadorP.c_str());
	stdp.writeStr(medioP.c_str());
	stdp.writeStr(score.c_str());
	stdp.writeStr(saltoP.c_str());
	stdp.writeStr(medioP.c_str());
	stdp.writeStr(separadorP.c_str());
	stdp.writeStr(salto.c_str());
	stdp.setColor(ABOLD, CWHITE, CBLACK);
	stdp.writeStr(suficiente.c_str());
	stdp.writeStr(saltoP.c_str());
	stdp.setColor(ABOLD, CYELLOW, CBLACK);
	stdp.writeStr(pauseT.c_str());
	while(rank != KESPACIO) rank=stdp.getKey();
	stdp.setColor(ABOLD, CWHITE, CBLACK);


}

